# coding: utf-8

"""
    Hitobito JSON:API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: v1
    Contact: oss@basilbader.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

import warnings
from pydantic import validate_call, Field, StrictFloat, StrictStr, StrictInt
from typing import Any, Dict, List, Optional, Tuple, Union
from typing_extensions import Annotated

from pydantic import Field, StrictInt, StrictStr, field_validator
from typing import List, Optional
from typing_extensions import Annotated
from jubladb_api.models.groups_readable_attribute import GroupsReadableAttribute
from jubladb_api.models.invoice_items_readable_attribute import InvoiceItemsReadableAttribute
from jubladb_api.models.invoices_collection import InvoicesCollection
from jubladb_api.models.invoices_readable_attribute import InvoicesReadableAttribute
from jubladb_api.models.invoices_request import InvoicesRequest
from jubladb_api.models.invoices_single import InvoicesSingle
from jubladb_api.models.people_readable_attribute import PeopleReadableAttribute

from jubladb_api.api_client import ApiClient, RequestSerialized
from jubladb_api.api_response import ApiResponse
from jubladb_api.rest import RESTResponseType


class InvoicesApi:
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None) -> None:
        if api_client is None:
            api_client = ApiClient.get_default()
        self.api_client = api_client


    @validate_call
    def get_invoice(
        self,
        id: Annotated[StrictStr, Field(description="ID of the resource")],
        include: Annotated[Optional[List[StrictStr]], Field(description="[Include related resources](https://jsonapi.org/format/#fetching-includes)")] = None,
        sort: Annotated[Optional[List[StrictStr]], Field(description="[Sort invoices according to one or more criteria](https://jsonapi.org/format/#fetching-sorting)  You should not include both ascending `id` and descending `-id` fields the same time  ")] = None,
        fields_invoices: Annotated[Optional[List[InvoicesReadableAttribute]], Field(description="[Include only specified fields of Invoice in response](https://jsonapi.org/format/#fetching-sparse-fieldsets)")] = None,
        filter_id_eq: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by id using eq operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_id_not_eq: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by id using not_eq operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_id_gt: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by id using gt operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_id_gte: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by id using gte operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_id_lt: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by id using lt operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_id_lte: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by id using lte operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_group_id_eq: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by group_id using eq operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_group_id_not_eq: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by group_id using not_eq operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_group_id_gt: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by group_id using gt operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_group_id_gte: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by group_id using gte operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_group_id_lt: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by group_id using lt operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_group_id_lte: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by group_id using lte operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_recipient_id_eq: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by recipient_id using eq operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_recipient_id_not_eq: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by recipient_id using not_eq operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_recipient_id_gt: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by recipient_id using gt operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_recipient_id_gte: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by recipient_id using gte operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_recipient_id_lt: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by recipient_id using lt operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_recipient_id_lte: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by recipient_id using lte operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        fields_groups: Annotated[Optional[List[GroupsReadableAttribute]], Field(description="[Include only specified fields of Group in response](https://jsonapi.org/format/#fetching-sparse-fieldsets)")] = None,
        fields_people: Annotated[Optional[List[PeopleReadableAttribute]], Field(description="[Include only specified fields of Person in response](https://jsonapi.org/format/#fetching-sparse-fieldsets)")] = None,
        fields_invoice_items: Annotated[Optional[List[InvoiceItemsReadableAttribute]], Field(description="[Include only specified fields of Invoice item in response](https://jsonapi.org/format/#fetching-sparse-fieldsets)")] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
        _additional_query_params: Optional[Dict[StrictStr, Any]] = None,
    ) -> InvoicesSingle:
        """Fetch Invoice


        :param id: ID of the resource (required)
        :type id: str
        :param include: [Include related resources](https://jsonapi.org/format/#fetching-includes)
        :type include: List[str]
        :param sort: [Sort invoices according to one or more criteria](https://jsonapi.org/format/#fetching-sorting)  You should not include both ascending `id` and descending `-id` fields the same time  
        :type sort: List[str]
        :param fields_invoices: [Include only specified fields of Invoice in response](https://jsonapi.org/format/#fetching-sparse-fieldsets)
        :type fields_invoices: List[InvoicesReadableAttribute]
        :param filter_id_eq: [Filter Invoice by id using eq operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_id_eq: List[int]
        :param filter_id_not_eq: [Filter Invoice by id using not_eq operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_id_not_eq: List[int]
        :param filter_id_gt: [Filter Invoice by id using gt operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_id_gt: List[int]
        :param filter_id_gte: [Filter Invoice by id using gte operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_id_gte: List[int]
        :param filter_id_lt: [Filter Invoice by id using lt operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_id_lt: List[int]
        :param filter_id_lte: [Filter Invoice by id using lte operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_id_lte: List[int]
        :param filter_group_id_eq: [Filter Invoice by group_id using eq operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_group_id_eq: List[int]
        :param filter_group_id_not_eq: [Filter Invoice by group_id using not_eq operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_group_id_not_eq: List[int]
        :param filter_group_id_gt: [Filter Invoice by group_id using gt operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_group_id_gt: List[int]
        :param filter_group_id_gte: [Filter Invoice by group_id using gte operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_group_id_gte: List[int]
        :param filter_group_id_lt: [Filter Invoice by group_id using lt operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_group_id_lt: List[int]
        :param filter_group_id_lte: [Filter Invoice by group_id using lte operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_group_id_lte: List[int]
        :param filter_recipient_id_eq: [Filter Invoice by recipient_id using eq operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_recipient_id_eq: List[int]
        :param filter_recipient_id_not_eq: [Filter Invoice by recipient_id using not_eq operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_recipient_id_not_eq: List[int]
        :param filter_recipient_id_gt: [Filter Invoice by recipient_id using gt operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_recipient_id_gt: List[int]
        :param filter_recipient_id_gte: [Filter Invoice by recipient_id using gte operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_recipient_id_gte: List[int]
        :param filter_recipient_id_lt: [Filter Invoice by recipient_id using lt operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_recipient_id_lt: List[int]
        :param filter_recipient_id_lte: [Filter Invoice by recipient_id using lte operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_recipient_id_lte: List[int]
        :param fields_groups: [Include only specified fields of Group in response](https://jsonapi.org/format/#fetching-sparse-fieldsets)
        :type fields_groups: List[GroupsReadableAttribute]
        :param fields_people: [Include only specified fields of Person in response](https://jsonapi.org/format/#fetching-sparse-fieldsets)
        :type fields_people: List[PeopleReadableAttribute]
        :param fields_invoice_items: [Include only specified fields of Invoice item in response](https://jsonapi.org/format/#fetching-sparse-fieldsets)
        :type fields_invoice_items: List[InvoiceItemsReadableAttribute]
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._get_invoice_serialize(
            id=id,
            include=include,
            sort=sort,
            fields_invoices=fields_invoices,
            filter_id_eq=filter_id_eq,
            filter_id_not_eq=filter_id_not_eq,
            filter_id_gt=filter_id_gt,
            filter_id_gte=filter_id_gte,
            filter_id_lt=filter_id_lt,
            filter_id_lte=filter_id_lte,
            filter_group_id_eq=filter_group_id_eq,
            filter_group_id_not_eq=filter_group_id_not_eq,
            filter_group_id_gt=filter_group_id_gt,
            filter_group_id_gte=filter_group_id_gte,
            filter_group_id_lt=filter_group_id_lt,
            filter_group_id_lte=filter_group_id_lte,
            filter_recipient_id_eq=filter_recipient_id_eq,
            filter_recipient_id_not_eq=filter_recipient_id_not_eq,
            filter_recipient_id_gt=filter_recipient_id_gt,
            filter_recipient_id_gte=filter_recipient_id_gte,
            filter_recipient_id_lt=filter_recipient_id_lt,
            filter_recipient_id_lte=filter_recipient_id_lte,
            fields_groups=fields_groups,
            fields_people=fields_people,
            fields_invoice_items=fields_invoice_items,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index,
            _additional_query_params=_additional_query_params,
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "InvoicesSingle",
            '401': "JsonapiFailure",
            '403': "JsonapiFailure",
            '404': "JsonapiFailure",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        ).data


    @validate_call
    def get_invoice_with_http_info(
        self,
        id: Annotated[StrictStr, Field(description="ID of the resource")],
        include: Annotated[Optional[List[StrictStr]], Field(description="[Include related resources](https://jsonapi.org/format/#fetching-includes)")] = None,
        sort: Annotated[Optional[List[StrictStr]], Field(description="[Sort invoices according to one or more criteria](https://jsonapi.org/format/#fetching-sorting)  You should not include both ascending `id` and descending `-id` fields the same time  ")] = None,
        fields_invoices: Annotated[Optional[List[InvoicesReadableAttribute]], Field(description="[Include only specified fields of Invoice in response](https://jsonapi.org/format/#fetching-sparse-fieldsets)")] = None,
        filter_id_eq: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by id using eq operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_id_not_eq: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by id using not_eq operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_id_gt: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by id using gt operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_id_gte: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by id using gte operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_id_lt: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by id using lt operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_id_lte: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by id using lte operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_group_id_eq: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by group_id using eq operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_group_id_not_eq: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by group_id using not_eq operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_group_id_gt: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by group_id using gt operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_group_id_gte: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by group_id using gte operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_group_id_lt: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by group_id using lt operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_group_id_lte: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by group_id using lte operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_recipient_id_eq: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by recipient_id using eq operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_recipient_id_not_eq: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by recipient_id using not_eq operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_recipient_id_gt: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by recipient_id using gt operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_recipient_id_gte: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by recipient_id using gte operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_recipient_id_lt: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by recipient_id using lt operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_recipient_id_lte: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by recipient_id using lte operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        fields_groups: Annotated[Optional[List[GroupsReadableAttribute]], Field(description="[Include only specified fields of Group in response](https://jsonapi.org/format/#fetching-sparse-fieldsets)")] = None,
        fields_people: Annotated[Optional[List[PeopleReadableAttribute]], Field(description="[Include only specified fields of Person in response](https://jsonapi.org/format/#fetching-sparse-fieldsets)")] = None,
        fields_invoice_items: Annotated[Optional[List[InvoiceItemsReadableAttribute]], Field(description="[Include only specified fields of Invoice item in response](https://jsonapi.org/format/#fetching-sparse-fieldsets)")] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
        _additional_query_params: Optional[Dict[StrictStr, Any]] = None,
    ) -> ApiResponse[InvoicesSingle]:
        """Fetch Invoice


        :param id: ID of the resource (required)
        :type id: str
        :param include: [Include related resources](https://jsonapi.org/format/#fetching-includes)
        :type include: List[str]
        :param sort: [Sort invoices according to one or more criteria](https://jsonapi.org/format/#fetching-sorting)  You should not include both ascending `id` and descending `-id` fields the same time  
        :type sort: List[str]
        :param fields_invoices: [Include only specified fields of Invoice in response](https://jsonapi.org/format/#fetching-sparse-fieldsets)
        :type fields_invoices: List[InvoicesReadableAttribute]
        :param filter_id_eq: [Filter Invoice by id using eq operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_id_eq: List[int]
        :param filter_id_not_eq: [Filter Invoice by id using not_eq operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_id_not_eq: List[int]
        :param filter_id_gt: [Filter Invoice by id using gt operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_id_gt: List[int]
        :param filter_id_gte: [Filter Invoice by id using gte operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_id_gte: List[int]
        :param filter_id_lt: [Filter Invoice by id using lt operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_id_lt: List[int]
        :param filter_id_lte: [Filter Invoice by id using lte operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_id_lte: List[int]
        :param filter_group_id_eq: [Filter Invoice by group_id using eq operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_group_id_eq: List[int]
        :param filter_group_id_not_eq: [Filter Invoice by group_id using not_eq operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_group_id_not_eq: List[int]
        :param filter_group_id_gt: [Filter Invoice by group_id using gt operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_group_id_gt: List[int]
        :param filter_group_id_gte: [Filter Invoice by group_id using gte operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_group_id_gte: List[int]
        :param filter_group_id_lt: [Filter Invoice by group_id using lt operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_group_id_lt: List[int]
        :param filter_group_id_lte: [Filter Invoice by group_id using lte operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_group_id_lte: List[int]
        :param filter_recipient_id_eq: [Filter Invoice by recipient_id using eq operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_recipient_id_eq: List[int]
        :param filter_recipient_id_not_eq: [Filter Invoice by recipient_id using not_eq operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_recipient_id_not_eq: List[int]
        :param filter_recipient_id_gt: [Filter Invoice by recipient_id using gt operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_recipient_id_gt: List[int]
        :param filter_recipient_id_gte: [Filter Invoice by recipient_id using gte operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_recipient_id_gte: List[int]
        :param filter_recipient_id_lt: [Filter Invoice by recipient_id using lt operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_recipient_id_lt: List[int]
        :param filter_recipient_id_lte: [Filter Invoice by recipient_id using lte operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_recipient_id_lte: List[int]
        :param fields_groups: [Include only specified fields of Group in response](https://jsonapi.org/format/#fetching-sparse-fieldsets)
        :type fields_groups: List[GroupsReadableAttribute]
        :param fields_people: [Include only specified fields of Person in response](https://jsonapi.org/format/#fetching-sparse-fieldsets)
        :type fields_people: List[PeopleReadableAttribute]
        :param fields_invoice_items: [Include only specified fields of Invoice item in response](https://jsonapi.org/format/#fetching-sparse-fieldsets)
        :type fields_invoice_items: List[InvoiceItemsReadableAttribute]
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._get_invoice_serialize(
            id=id,
            include=include,
            sort=sort,
            fields_invoices=fields_invoices,
            filter_id_eq=filter_id_eq,
            filter_id_not_eq=filter_id_not_eq,
            filter_id_gt=filter_id_gt,
            filter_id_gte=filter_id_gte,
            filter_id_lt=filter_id_lt,
            filter_id_lte=filter_id_lte,
            filter_group_id_eq=filter_group_id_eq,
            filter_group_id_not_eq=filter_group_id_not_eq,
            filter_group_id_gt=filter_group_id_gt,
            filter_group_id_gte=filter_group_id_gte,
            filter_group_id_lt=filter_group_id_lt,
            filter_group_id_lte=filter_group_id_lte,
            filter_recipient_id_eq=filter_recipient_id_eq,
            filter_recipient_id_not_eq=filter_recipient_id_not_eq,
            filter_recipient_id_gt=filter_recipient_id_gt,
            filter_recipient_id_gte=filter_recipient_id_gte,
            filter_recipient_id_lt=filter_recipient_id_lt,
            filter_recipient_id_lte=filter_recipient_id_lte,
            fields_groups=fields_groups,
            fields_people=fields_people,
            fields_invoice_items=fields_invoice_items,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index,
            _additional_query_params=_additional_query_params,
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "InvoicesSingle",
            '401': "JsonapiFailure",
            '403': "JsonapiFailure",
            '404': "JsonapiFailure",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        )


    @validate_call
    def get_invoice_without_preload_content(
        self,
        id: Annotated[StrictStr, Field(description="ID of the resource")],
        include: Annotated[Optional[List[StrictStr]], Field(description="[Include related resources](https://jsonapi.org/format/#fetching-includes)")] = None,
        sort: Annotated[Optional[List[StrictStr]], Field(description="[Sort invoices according to one or more criteria](https://jsonapi.org/format/#fetching-sorting)  You should not include both ascending `id` and descending `-id` fields the same time  ")] = None,
        fields_invoices: Annotated[Optional[List[InvoicesReadableAttribute]], Field(description="[Include only specified fields of Invoice in response](https://jsonapi.org/format/#fetching-sparse-fieldsets)")] = None,
        filter_id_eq: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by id using eq operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_id_not_eq: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by id using not_eq operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_id_gt: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by id using gt operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_id_gte: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by id using gte operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_id_lt: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by id using lt operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_id_lte: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by id using lte operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_group_id_eq: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by group_id using eq operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_group_id_not_eq: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by group_id using not_eq operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_group_id_gt: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by group_id using gt operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_group_id_gte: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by group_id using gte operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_group_id_lt: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by group_id using lt operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_group_id_lte: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by group_id using lte operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_recipient_id_eq: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by recipient_id using eq operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_recipient_id_not_eq: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by recipient_id using not_eq operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_recipient_id_gt: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by recipient_id using gt operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_recipient_id_gte: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by recipient_id using gte operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_recipient_id_lt: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by recipient_id using lt operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_recipient_id_lte: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by recipient_id using lte operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        fields_groups: Annotated[Optional[List[GroupsReadableAttribute]], Field(description="[Include only specified fields of Group in response](https://jsonapi.org/format/#fetching-sparse-fieldsets)")] = None,
        fields_people: Annotated[Optional[List[PeopleReadableAttribute]], Field(description="[Include only specified fields of Person in response](https://jsonapi.org/format/#fetching-sparse-fieldsets)")] = None,
        fields_invoice_items: Annotated[Optional[List[InvoiceItemsReadableAttribute]], Field(description="[Include only specified fields of Invoice item in response](https://jsonapi.org/format/#fetching-sparse-fieldsets)")] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
        _additional_query_params: Optional[Dict[StrictStr, Any]] = None,
    ) -> RESTResponseType:
        """Fetch Invoice


        :param id: ID of the resource (required)
        :type id: str
        :param include: [Include related resources](https://jsonapi.org/format/#fetching-includes)
        :type include: List[str]
        :param sort: [Sort invoices according to one or more criteria](https://jsonapi.org/format/#fetching-sorting)  You should not include both ascending `id` and descending `-id` fields the same time  
        :type sort: List[str]
        :param fields_invoices: [Include only specified fields of Invoice in response](https://jsonapi.org/format/#fetching-sparse-fieldsets)
        :type fields_invoices: List[InvoicesReadableAttribute]
        :param filter_id_eq: [Filter Invoice by id using eq operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_id_eq: List[int]
        :param filter_id_not_eq: [Filter Invoice by id using not_eq operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_id_not_eq: List[int]
        :param filter_id_gt: [Filter Invoice by id using gt operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_id_gt: List[int]
        :param filter_id_gte: [Filter Invoice by id using gte operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_id_gte: List[int]
        :param filter_id_lt: [Filter Invoice by id using lt operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_id_lt: List[int]
        :param filter_id_lte: [Filter Invoice by id using lte operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_id_lte: List[int]
        :param filter_group_id_eq: [Filter Invoice by group_id using eq operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_group_id_eq: List[int]
        :param filter_group_id_not_eq: [Filter Invoice by group_id using not_eq operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_group_id_not_eq: List[int]
        :param filter_group_id_gt: [Filter Invoice by group_id using gt operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_group_id_gt: List[int]
        :param filter_group_id_gte: [Filter Invoice by group_id using gte operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_group_id_gte: List[int]
        :param filter_group_id_lt: [Filter Invoice by group_id using lt operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_group_id_lt: List[int]
        :param filter_group_id_lte: [Filter Invoice by group_id using lte operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_group_id_lte: List[int]
        :param filter_recipient_id_eq: [Filter Invoice by recipient_id using eq operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_recipient_id_eq: List[int]
        :param filter_recipient_id_not_eq: [Filter Invoice by recipient_id using not_eq operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_recipient_id_not_eq: List[int]
        :param filter_recipient_id_gt: [Filter Invoice by recipient_id using gt operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_recipient_id_gt: List[int]
        :param filter_recipient_id_gte: [Filter Invoice by recipient_id using gte operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_recipient_id_gte: List[int]
        :param filter_recipient_id_lt: [Filter Invoice by recipient_id using lt operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_recipient_id_lt: List[int]
        :param filter_recipient_id_lte: [Filter Invoice by recipient_id using lte operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_recipient_id_lte: List[int]
        :param fields_groups: [Include only specified fields of Group in response](https://jsonapi.org/format/#fetching-sparse-fieldsets)
        :type fields_groups: List[GroupsReadableAttribute]
        :param fields_people: [Include only specified fields of Person in response](https://jsonapi.org/format/#fetching-sparse-fieldsets)
        :type fields_people: List[PeopleReadableAttribute]
        :param fields_invoice_items: [Include only specified fields of Invoice item in response](https://jsonapi.org/format/#fetching-sparse-fieldsets)
        :type fields_invoice_items: List[InvoiceItemsReadableAttribute]
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._get_invoice_serialize(
            id=id,
            include=include,
            sort=sort,
            fields_invoices=fields_invoices,
            filter_id_eq=filter_id_eq,
            filter_id_not_eq=filter_id_not_eq,
            filter_id_gt=filter_id_gt,
            filter_id_gte=filter_id_gte,
            filter_id_lt=filter_id_lt,
            filter_id_lte=filter_id_lte,
            filter_group_id_eq=filter_group_id_eq,
            filter_group_id_not_eq=filter_group_id_not_eq,
            filter_group_id_gt=filter_group_id_gt,
            filter_group_id_gte=filter_group_id_gte,
            filter_group_id_lt=filter_group_id_lt,
            filter_group_id_lte=filter_group_id_lte,
            filter_recipient_id_eq=filter_recipient_id_eq,
            filter_recipient_id_not_eq=filter_recipient_id_not_eq,
            filter_recipient_id_gt=filter_recipient_id_gt,
            filter_recipient_id_gte=filter_recipient_id_gte,
            filter_recipient_id_lt=filter_recipient_id_lt,
            filter_recipient_id_lte=filter_recipient_id_lte,
            fields_groups=fields_groups,
            fields_people=fields_people,
            fields_invoice_items=fields_invoice_items,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index,
            _additional_query_params=_additional_query_params,
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "InvoicesSingle",
            '401': "JsonapiFailure",
            '403': "JsonapiFailure",
            '404': "JsonapiFailure",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        return response_data.response


    def _get_invoice_serialize(
        self,
        id,
        include,
        sort,
        fields_invoices,
        filter_id_eq,
        filter_id_not_eq,
        filter_id_gt,
        filter_id_gte,
        filter_id_lt,
        filter_id_lte,
        filter_group_id_eq,
        filter_group_id_not_eq,
        filter_group_id_gt,
        filter_group_id_gte,
        filter_group_id_lt,
        filter_group_id_lte,
        filter_recipient_id_eq,
        filter_recipient_id_not_eq,
        filter_recipient_id_gt,
        filter_recipient_id_gte,
        filter_recipient_id_lt,
        filter_recipient_id_lte,
        fields_groups,
        fields_people,
        fields_invoice_items,
        _request_auth,
        _content_type,
        _headers,
        _host_index,
        _additional_query_params: Optional[Dict[StrictStr, Any]] = None,
    ) -> RequestSerialized:

        _host = None

        _collection_formats: Dict[str, str] = {
            'include': 'csv',
            'sort': 'csv',
            'fields[invoices]': 'csv',
            'filter[id][eq]': 'csv',
            'filter[id][not_eq]': 'csv',
            'filter[id][gt]': 'csv',
            'filter[id][gte]': 'csv',
            'filter[id][lt]': 'csv',
            'filter[id][lte]': 'csv',
            'filter[group_id][eq]': 'csv',
            'filter[group_id][not_eq]': 'csv',
            'filter[group_id][gt]': 'csv',
            'filter[group_id][gte]': 'csv',
            'filter[group_id][lt]': 'csv',
            'filter[group_id][lte]': 'csv',
            'filter[recipient_id][eq]': 'csv',
            'filter[recipient_id][not_eq]': 'csv',
            'filter[recipient_id][gt]': 'csv',
            'filter[recipient_id][gte]': 'csv',
            'filter[recipient_id][lt]': 'csv',
            'filter[recipient_id][lte]': 'csv',
            'fields[groups]': 'csv',
            'fields[people]': 'csv',
            'fields[invoice_items]': 'csv',
        }

        _path_params: Dict[str, str] = {}
        _query_params: List[Tuple[str, str]] = []
        _header_params: Dict[str, Optional[str]] = _headers or {}
        _form_params: List[Tuple[str, str]] = []
        _files: Dict[
            str, Union[str, bytes, List[str], List[bytes], List[Tuple[str, bytes]]]
        ] = {}
        _body_params: Optional[bytes] = None

        # process the path parameters
        if id is not None:
            _path_params['id'] = id
        # process the query parameters

        if _additional_query_params is not None:
            _query_params.extend((key, value) for key, value in _additional_query_params.items())

        if include is not None:
            
            _query_params.append(('include', include))
            
        if sort is not None:
            
            _query_params.append(('sort', sort))
            
        if fields_invoices is not None:
            
            _query_params.append(('fields[invoices]', fields_invoices))
            
        if filter_id_eq is not None:
            
            _query_params.append(('filter[id][eq]', filter_id_eq))
            
        if filter_id_not_eq is not None:
            
            _query_params.append(('filter[id][not_eq]', filter_id_not_eq))
            
        if filter_id_gt is not None:
            
            _query_params.append(('filter[id][gt]', filter_id_gt))
            
        if filter_id_gte is not None:
            
            _query_params.append(('filter[id][gte]', filter_id_gte))
            
        if filter_id_lt is not None:
            
            _query_params.append(('filter[id][lt]', filter_id_lt))
            
        if filter_id_lte is not None:
            
            _query_params.append(('filter[id][lte]', filter_id_lte))
            
        if filter_group_id_eq is not None:
            
            _query_params.append(('filter[group_id][eq]', filter_group_id_eq))
            
        if filter_group_id_not_eq is not None:
            
            _query_params.append(('filter[group_id][not_eq]', filter_group_id_not_eq))
            
        if filter_group_id_gt is not None:
            
            _query_params.append(('filter[group_id][gt]', filter_group_id_gt))
            
        if filter_group_id_gte is not None:
            
            _query_params.append(('filter[group_id][gte]', filter_group_id_gte))
            
        if filter_group_id_lt is not None:
            
            _query_params.append(('filter[group_id][lt]', filter_group_id_lt))
            
        if filter_group_id_lte is not None:
            
            _query_params.append(('filter[group_id][lte]', filter_group_id_lte))
            
        if filter_recipient_id_eq is not None:
            
            _query_params.append(('filter[recipient_id][eq]', filter_recipient_id_eq))
            
        if filter_recipient_id_not_eq is not None:
            
            _query_params.append(('filter[recipient_id][not_eq]', filter_recipient_id_not_eq))
            
        if filter_recipient_id_gt is not None:
            
            _query_params.append(('filter[recipient_id][gt]', filter_recipient_id_gt))
            
        if filter_recipient_id_gte is not None:
            
            _query_params.append(('filter[recipient_id][gte]', filter_recipient_id_gte))
            
        if filter_recipient_id_lt is not None:
            
            _query_params.append(('filter[recipient_id][lt]', filter_recipient_id_lt))
            
        if filter_recipient_id_lte is not None:
            
            _query_params.append(('filter[recipient_id][lte]', filter_recipient_id_lte))
            
        if fields_groups is not None:
            
            _query_params.append(('fields[groups]', fields_groups))
            
        if fields_people is not None:
            
            _query_params.append(('fields[people]', fields_people))
            
        if fields_invoice_items is not None:
            
            _query_params.append(('fields[invoice_items]', fields_invoice_items))
            
        # process the header parameters
        # process the form parameters
        # process the body parameter


        # set the HTTP header `Accept`
        if 'Accept' not in _header_params:
            _header_params['Accept'] = self.api_client.select_header_accept(
                [
                    'application/vnd.api+json'
                ]
            )


        # authentication setting
        _auth_settings: List[str] = [
            'ServiceTokenAuthHeader', 
            'ServiceTokenAuthParam'
        ]

        return self.api_client.param_serialize(
            method='GET',
            resource_path='/api/invoices/{id}',
            path_params=_path_params,
            query_params=_query_params,
            header_params=_header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            auth_settings=_auth_settings,
            collection_formats=_collection_formats,
            _host=_host,
            _request_auth=_request_auth
        )




    @validate_call
    def list_invoices(
        self,
        include: Annotated[Optional[List[StrictStr]], Field(description="[Include related resources](https://jsonapi.org/format/#fetching-includes)")] = None,
        sort: Annotated[Optional[List[StrictStr]], Field(description="[Sort invoices according to one or more criteria](https://jsonapi.org/format/#fetching-sorting)  You should not include both ascending `id` and descending `-id` fields the same time  ")] = None,
        fields_invoices: Annotated[Optional[List[InvoicesReadableAttribute]], Field(description="[Include only specified fields of Invoice in response](https://jsonapi.org/format/#fetching-sparse-fieldsets)")] = None,
        filter_id_eq: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by id using eq operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_id_not_eq: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by id using not_eq operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_id_gt: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by id using gt operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_id_gte: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by id using gte operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_id_lt: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by id using lt operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_id_lte: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by id using lte operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_group_id_eq: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by group_id using eq operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_group_id_not_eq: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by group_id using not_eq operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_group_id_gt: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by group_id using gt operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_group_id_gte: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by group_id using gte operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_group_id_lt: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by group_id using lt operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_group_id_lte: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by group_id using lte operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_recipient_id_eq: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by recipient_id using eq operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_recipient_id_not_eq: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by recipient_id using not_eq operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_recipient_id_gt: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by recipient_id using gt operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_recipient_id_gte: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by recipient_id using gte operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_recipient_id_lt: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by recipient_id using lt operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_recipient_id_lte: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by recipient_id using lte operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        fields_groups: Annotated[Optional[List[GroupsReadableAttribute]], Field(description="[Include only specified fields of Group in response](https://jsonapi.org/format/#fetching-sparse-fieldsets)")] = None,
        fields_people: Annotated[Optional[List[PeopleReadableAttribute]], Field(description="[Include only specified fields of Person in response](https://jsonapi.org/format/#fetching-sparse-fieldsets)")] = None,
        fields_invoice_items: Annotated[Optional[List[InvoiceItemsReadableAttribute]], Field(description="[Include only specified fields of Invoice item in response](https://jsonapi.org/format/#fetching-sparse-fieldsets)")] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
        _additional_query_params: Optional[Dict[StrictStr, Any]] = None,
    ) -> InvoicesCollection:
        """List Invoices


        :param include: [Include related resources](https://jsonapi.org/format/#fetching-includes)
        :type include: List[str]
        :param sort: [Sort invoices according to one or more criteria](https://jsonapi.org/format/#fetching-sorting)  You should not include both ascending `id` and descending `-id` fields the same time  
        :type sort: List[str]
        :param fields_invoices: [Include only specified fields of Invoice in response](https://jsonapi.org/format/#fetching-sparse-fieldsets)
        :type fields_invoices: List[InvoicesReadableAttribute]
        :param filter_id_eq: [Filter Invoice by id using eq operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_id_eq: List[int]
        :param filter_id_not_eq: [Filter Invoice by id using not_eq operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_id_not_eq: List[int]
        :param filter_id_gt: [Filter Invoice by id using gt operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_id_gt: List[int]
        :param filter_id_gte: [Filter Invoice by id using gte operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_id_gte: List[int]
        :param filter_id_lt: [Filter Invoice by id using lt operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_id_lt: List[int]
        :param filter_id_lte: [Filter Invoice by id using lte operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_id_lte: List[int]
        :param filter_group_id_eq: [Filter Invoice by group_id using eq operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_group_id_eq: List[int]
        :param filter_group_id_not_eq: [Filter Invoice by group_id using not_eq operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_group_id_not_eq: List[int]
        :param filter_group_id_gt: [Filter Invoice by group_id using gt operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_group_id_gt: List[int]
        :param filter_group_id_gte: [Filter Invoice by group_id using gte operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_group_id_gte: List[int]
        :param filter_group_id_lt: [Filter Invoice by group_id using lt operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_group_id_lt: List[int]
        :param filter_group_id_lte: [Filter Invoice by group_id using lte operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_group_id_lte: List[int]
        :param filter_recipient_id_eq: [Filter Invoice by recipient_id using eq operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_recipient_id_eq: List[int]
        :param filter_recipient_id_not_eq: [Filter Invoice by recipient_id using not_eq operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_recipient_id_not_eq: List[int]
        :param filter_recipient_id_gt: [Filter Invoice by recipient_id using gt operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_recipient_id_gt: List[int]
        :param filter_recipient_id_gte: [Filter Invoice by recipient_id using gte operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_recipient_id_gte: List[int]
        :param filter_recipient_id_lt: [Filter Invoice by recipient_id using lt operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_recipient_id_lt: List[int]
        :param filter_recipient_id_lte: [Filter Invoice by recipient_id using lte operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_recipient_id_lte: List[int]
        :param fields_groups: [Include only specified fields of Group in response](https://jsonapi.org/format/#fetching-sparse-fieldsets)
        :type fields_groups: List[GroupsReadableAttribute]
        :param fields_people: [Include only specified fields of Person in response](https://jsonapi.org/format/#fetching-sparse-fieldsets)
        :type fields_people: List[PeopleReadableAttribute]
        :param fields_invoice_items: [Include only specified fields of Invoice item in response](https://jsonapi.org/format/#fetching-sparse-fieldsets)
        :type fields_invoice_items: List[InvoiceItemsReadableAttribute]
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._list_invoices_serialize(
            include=include,
            sort=sort,
            fields_invoices=fields_invoices,
            filter_id_eq=filter_id_eq,
            filter_id_not_eq=filter_id_not_eq,
            filter_id_gt=filter_id_gt,
            filter_id_gte=filter_id_gte,
            filter_id_lt=filter_id_lt,
            filter_id_lte=filter_id_lte,
            filter_group_id_eq=filter_group_id_eq,
            filter_group_id_not_eq=filter_group_id_not_eq,
            filter_group_id_gt=filter_group_id_gt,
            filter_group_id_gte=filter_group_id_gte,
            filter_group_id_lt=filter_group_id_lt,
            filter_group_id_lte=filter_group_id_lte,
            filter_recipient_id_eq=filter_recipient_id_eq,
            filter_recipient_id_not_eq=filter_recipient_id_not_eq,
            filter_recipient_id_gt=filter_recipient_id_gt,
            filter_recipient_id_gte=filter_recipient_id_gte,
            filter_recipient_id_lt=filter_recipient_id_lt,
            filter_recipient_id_lte=filter_recipient_id_lte,
            fields_groups=fields_groups,
            fields_people=fields_people,
            fields_invoice_items=fields_invoice_items,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index,
            _additional_query_params=_additional_query_params,
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "InvoicesCollection",
            '401': "JsonapiFailure",
            '403': "JsonapiFailure",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        ).data


    @validate_call
    def list_invoices_with_http_info(
        self,
        include: Annotated[Optional[List[StrictStr]], Field(description="[Include related resources](https://jsonapi.org/format/#fetching-includes)")] = None,
        sort: Annotated[Optional[List[StrictStr]], Field(description="[Sort invoices according to one or more criteria](https://jsonapi.org/format/#fetching-sorting)  You should not include both ascending `id` and descending `-id` fields the same time  ")] = None,
        fields_invoices: Annotated[Optional[List[InvoicesReadableAttribute]], Field(description="[Include only specified fields of Invoice in response](https://jsonapi.org/format/#fetching-sparse-fieldsets)")] = None,
        filter_id_eq: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by id using eq operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_id_not_eq: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by id using not_eq operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_id_gt: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by id using gt operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_id_gte: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by id using gte operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_id_lt: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by id using lt operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_id_lte: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by id using lte operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_group_id_eq: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by group_id using eq operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_group_id_not_eq: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by group_id using not_eq operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_group_id_gt: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by group_id using gt operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_group_id_gte: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by group_id using gte operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_group_id_lt: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by group_id using lt operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_group_id_lte: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by group_id using lte operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_recipient_id_eq: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by recipient_id using eq operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_recipient_id_not_eq: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by recipient_id using not_eq operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_recipient_id_gt: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by recipient_id using gt operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_recipient_id_gte: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by recipient_id using gte operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_recipient_id_lt: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by recipient_id using lt operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_recipient_id_lte: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by recipient_id using lte operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        fields_groups: Annotated[Optional[List[GroupsReadableAttribute]], Field(description="[Include only specified fields of Group in response](https://jsonapi.org/format/#fetching-sparse-fieldsets)")] = None,
        fields_people: Annotated[Optional[List[PeopleReadableAttribute]], Field(description="[Include only specified fields of Person in response](https://jsonapi.org/format/#fetching-sparse-fieldsets)")] = None,
        fields_invoice_items: Annotated[Optional[List[InvoiceItemsReadableAttribute]], Field(description="[Include only specified fields of Invoice item in response](https://jsonapi.org/format/#fetching-sparse-fieldsets)")] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
        _additional_query_params: Optional[Dict[StrictStr, Any]] = None,
    ) -> ApiResponse[InvoicesCollection]:
        """List Invoices


        :param include: [Include related resources](https://jsonapi.org/format/#fetching-includes)
        :type include: List[str]
        :param sort: [Sort invoices according to one or more criteria](https://jsonapi.org/format/#fetching-sorting)  You should not include both ascending `id` and descending `-id` fields the same time  
        :type sort: List[str]
        :param fields_invoices: [Include only specified fields of Invoice in response](https://jsonapi.org/format/#fetching-sparse-fieldsets)
        :type fields_invoices: List[InvoicesReadableAttribute]
        :param filter_id_eq: [Filter Invoice by id using eq operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_id_eq: List[int]
        :param filter_id_not_eq: [Filter Invoice by id using not_eq operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_id_not_eq: List[int]
        :param filter_id_gt: [Filter Invoice by id using gt operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_id_gt: List[int]
        :param filter_id_gte: [Filter Invoice by id using gte operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_id_gte: List[int]
        :param filter_id_lt: [Filter Invoice by id using lt operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_id_lt: List[int]
        :param filter_id_lte: [Filter Invoice by id using lte operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_id_lte: List[int]
        :param filter_group_id_eq: [Filter Invoice by group_id using eq operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_group_id_eq: List[int]
        :param filter_group_id_not_eq: [Filter Invoice by group_id using not_eq operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_group_id_not_eq: List[int]
        :param filter_group_id_gt: [Filter Invoice by group_id using gt operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_group_id_gt: List[int]
        :param filter_group_id_gte: [Filter Invoice by group_id using gte operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_group_id_gte: List[int]
        :param filter_group_id_lt: [Filter Invoice by group_id using lt operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_group_id_lt: List[int]
        :param filter_group_id_lte: [Filter Invoice by group_id using lte operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_group_id_lte: List[int]
        :param filter_recipient_id_eq: [Filter Invoice by recipient_id using eq operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_recipient_id_eq: List[int]
        :param filter_recipient_id_not_eq: [Filter Invoice by recipient_id using not_eq operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_recipient_id_not_eq: List[int]
        :param filter_recipient_id_gt: [Filter Invoice by recipient_id using gt operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_recipient_id_gt: List[int]
        :param filter_recipient_id_gte: [Filter Invoice by recipient_id using gte operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_recipient_id_gte: List[int]
        :param filter_recipient_id_lt: [Filter Invoice by recipient_id using lt operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_recipient_id_lt: List[int]
        :param filter_recipient_id_lte: [Filter Invoice by recipient_id using lte operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_recipient_id_lte: List[int]
        :param fields_groups: [Include only specified fields of Group in response](https://jsonapi.org/format/#fetching-sparse-fieldsets)
        :type fields_groups: List[GroupsReadableAttribute]
        :param fields_people: [Include only specified fields of Person in response](https://jsonapi.org/format/#fetching-sparse-fieldsets)
        :type fields_people: List[PeopleReadableAttribute]
        :param fields_invoice_items: [Include only specified fields of Invoice item in response](https://jsonapi.org/format/#fetching-sparse-fieldsets)
        :type fields_invoice_items: List[InvoiceItemsReadableAttribute]
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._list_invoices_serialize(
            include=include,
            sort=sort,
            fields_invoices=fields_invoices,
            filter_id_eq=filter_id_eq,
            filter_id_not_eq=filter_id_not_eq,
            filter_id_gt=filter_id_gt,
            filter_id_gte=filter_id_gte,
            filter_id_lt=filter_id_lt,
            filter_id_lte=filter_id_lte,
            filter_group_id_eq=filter_group_id_eq,
            filter_group_id_not_eq=filter_group_id_not_eq,
            filter_group_id_gt=filter_group_id_gt,
            filter_group_id_gte=filter_group_id_gte,
            filter_group_id_lt=filter_group_id_lt,
            filter_group_id_lte=filter_group_id_lte,
            filter_recipient_id_eq=filter_recipient_id_eq,
            filter_recipient_id_not_eq=filter_recipient_id_not_eq,
            filter_recipient_id_gt=filter_recipient_id_gt,
            filter_recipient_id_gte=filter_recipient_id_gte,
            filter_recipient_id_lt=filter_recipient_id_lt,
            filter_recipient_id_lte=filter_recipient_id_lte,
            fields_groups=fields_groups,
            fields_people=fields_people,
            fields_invoice_items=fields_invoice_items,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index,
            _additional_query_params=_additional_query_params,
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "InvoicesCollection",
            '401': "JsonapiFailure",
            '403': "JsonapiFailure",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        )


    @validate_call
    def list_invoices_without_preload_content(
        self,
        include: Annotated[Optional[List[StrictStr]], Field(description="[Include related resources](https://jsonapi.org/format/#fetching-includes)")] = None,
        sort: Annotated[Optional[List[StrictStr]], Field(description="[Sort invoices according to one or more criteria](https://jsonapi.org/format/#fetching-sorting)  You should not include both ascending `id` and descending `-id` fields the same time  ")] = None,
        fields_invoices: Annotated[Optional[List[InvoicesReadableAttribute]], Field(description="[Include only specified fields of Invoice in response](https://jsonapi.org/format/#fetching-sparse-fieldsets)")] = None,
        filter_id_eq: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by id using eq operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_id_not_eq: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by id using not_eq operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_id_gt: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by id using gt operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_id_gte: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by id using gte operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_id_lt: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by id using lt operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_id_lte: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by id using lte operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_group_id_eq: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by group_id using eq operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_group_id_not_eq: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by group_id using not_eq operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_group_id_gt: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by group_id using gt operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_group_id_gte: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by group_id using gte operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_group_id_lt: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by group_id using lt operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_group_id_lte: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by group_id using lte operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_recipient_id_eq: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by recipient_id using eq operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_recipient_id_not_eq: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by recipient_id using not_eq operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_recipient_id_gt: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by recipient_id using gt operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_recipient_id_gte: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by recipient_id using gte operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_recipient_id_lt: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by recipient_id using lt operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_recipient_id_lte: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by recipient_id using lte operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        fields_groups: Annotated[Optional[List[GroupsReadableAttribute]], Field(description="[Include only specified fields of Group in response](https://jsonapi.org/format/#fetching-sparse-fieldsets)")] = None,
        fields_people: Annotated[Optional[List[PeopleReadableAttribute]], Field(description="[Include only specified fields of Person in response](https://jsonapi.org/format/#fetching-sparse-fieldsets)")] = None,
        fields_invoice_items: Annotated[Optional[List[InvoiceItemsReadableAttribute]], Field(description="[Include only specified fields of Invoice item in response](https://jsonapi.org/format/#fetching-sparse-fieldsets)")] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
        _additional_query_params: Optional[Dict[StrictStr, Any]] = None,
    ) -> RESTResponseType:
        """List Invoices


        :param include: [Include related resources](https://jsonapi.org/format/#fetching-includes)
        :type include: List[str]
        :param sort: [Sort invoices according to one or more criteria](https://jsonapi.org/format/#fetching-sorting)  You should not include both ascending `id` and descending `-id` fields the same time  
        :type sort: List[str]
        :param fields_invoices: [Include only specified fields of Invoice in response](https://jsonapi.org/format/#fetching-sparse-fieldsets)
        :type fields_invoices: List[InvoicesReadableAttribute]
        :param filter_id_eq: [Filter Invoice by id using eq operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_id_eq: List[int]
        :param filter_id_not_eq: [Filter Invoice by id using not_eq operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_id_not_eq: List[int]
        :param filter_id_gt: [Filter Invoice by id using gt operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_id_gt: List[int]
        :param filter_id_gte: [Filter Invoice by id using gte operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_id_gte: List[int]
        :param filter_id_lt: [Filter Invoice by id using lt operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_id_lt: List[int]
        :param filter_id_lte: [Filter Invoice by id using lte operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_id_lte: List[int]
        :param filter_group_id_eq: [Filter Invoice by group_id using eq operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_group_id_eq: List[int]
        :param filter_group_id_not_eq: [Filter Invoice by group_id using not_eq operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_group_id_not_eq: List[int]
        :param filter_group_id_gt: [Filter Invoice by group_id using gt operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_group_id_gt: List[int]
        :param filter_group_id_gte: [Filter Invoice by group_id using gte operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_group_id_gte: List[int]
        :param filter_group_id_lt: [Filter Invoice by group_id using lt operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_group_id_lt: List[int]
        :param filter_group_id_lte: [Filter Invoice by group_id using lte operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_group_id_lte: List[int]
        :param filter_recipient_id_eq: [Filter Invoice by recipient_id using eq operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_recipient_id_eq: List[int]
        :param filter_recipient_id_not_eq: [Filter Invoice by recipient_id using not_eq operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_recipient_id_not_eq: List[int]
        :param filter_recipient_id_gt: [Filter Invoice by recipient_id using gt operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_recipient_id_gt: List[int]
        :param filter_recipient_id_gte: [Filter Invoice by recipient_id using gte operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_recipient_id_gte: List[int]
        :param filter_recipient_id_lt: [Filter Invoice by recipient_id using lt operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_recipient_id_lt: List[int]
        :param filter_recipient_id_lte: [Filter Invoice by recipient_id using lte operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_recipient_id_lte: List[int]
        :param fields_groups: [Include only specified fields of Group in response](https://jsonapi.org/format/#fetching-sparse-fieldsets)
        :type fields_groups: List[GroupsReadableAttribute]
        :param fields_people: [Include only specified fields of Person in response](https://jsonapi.org/format/#fetching-sparse-fieldsets)
        :type fields_people: List[PeopleReadableAttribute]
        :param fields_invoice_items: [Include only specified fields of Invoice item in response](https://jsonapi.org/format/#fetching-sparse-fieldsets)
        :type fields_invoice_items: List[InvoiceItemsReadableAttribute]
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._list_invoices_serialize(
            include=include,
            sort=sort,
            fields_invoices=fields_invoices,
            filter_id_eq=filter_id_eq,
            filter_id_not_eq=filter_id_not_eq,
            filter_id_gt=filter_id_gt,
            filter_id_gte=filter_id_gte,
            filter_id_lt=filter_id_lt,
            filter_id_lte=filter_id_lte,
            filter_group_id_eq=filter_group_id_eq,
            filter_group_id_not_eq=filter_group_id_not_eq,
            filter_group_id_gt=filter_group_id_gt,
            filter_group_id_gte=filter_group_id_gte,
            filter_group_id_lt=filter_group_id_lt,
            filter_group_id_lte=filter_group_id_lte,
            filter_recipient_id_eq=filter_recipient_id_eq,
            filter_recipient_id_not_eq=filter_recipient_id_not_eq,
            filter_recipient_id_gt=filter_recipient_id_gt,
            filter_recipient_id_gte=filter_recipient_id_gte,
            filter_recipient_id_lt=filter_recipient_id_lt,
            filter_recipient_id_lte=filter_recipient_id_lte,
            fields_groups=fields_groups,
            fields_people=fields_people,
            fields_invoice_items=fields_invoice_items,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index,
            _additional_query_params=_additional_query_params,
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "InvoicesCollection",
            '401': "JsonapiFailure",
            '403': "JsonapiFailure",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        return response_data.response


    def _list_invoices_serialize(
        self,
        include,
        sort,
        fields_invoices,
        filter_id_eq,
        filter_id_not_eq,
        filter_id_gt,
        filter_id_gte,
        filter_id_lt,
        filter_id_lte,
        filter_group_id_eq,
        filter_group_id_not_eq,
        filter_group_id_gt,
        filter_group_id_gte,
        filter_group_id_lt,
        filter_group_id_lte,
        filter_recipient_id_eq,
        filter_recipient_id_not_eq,
        filter_recipient_id_gt,
        filter_recipient_id_gte,
        filter_recipient_id_lt,
        filter_recipient_id_lte,
        fields_groups,
        fields_people,
        fields_invoice_items,
        _request_auth,
        _content_type,
        _headers,
        _host_index,
        _additional_query_params: Optional[Dict[StrictStr, Any]] = None,
    ) -> RequestSerialized:

        _host = None

        _collection_formats: Dict[str, str] = {
            'include': 'csv',
            'sort': 'csv',
            'fields[invoices]': 'csv',
            'filter[id][eq]': 'csv',
            'filter[id][not_eq]': 'csv',
            'filter[id][gt]': 'csv',
            'filter[id][gte]': 'csv',
            'filter[id][lt]': 'csv',
            'filter[id][lte]': 'csv',
            'filter[group_id][eq]': 'csv',
            'filter[group_id][not_eq]': 'csv',
            'filter[group_id][gt]': 'csv',
            'filter[group_id][gte]': 'csv',
            'filter[group_id][lt]': 'csv',
            'filter[group_id][lte]': 'csv',
            'filter[recipient_id][eq]': 'csv',
            'filter[recipient_id][not_eq]': 'csv',
            'filter[recipient_id][gt]': 'csv',
            'filter[recipient_id][gte]': 'csv',
            'filter[recipient_id][lt]': 'csv',
            'filter[recipient_id][lte]': 'csv',
            'fields[groups]': 'csv',
            'fields[people]': 'csv',
            'fields[invoice_items]': 'csv',
        }

        _path_params: Dict[str, str] = {}
        _query_params: List[Tuple[str, str]] = []
        _header_params: Dict[str, Optional[str]] = _headers or {}
        _form_params: List[Tuple[str, str]] = []
        _files: Dict[
            str, Union[str, bytes, List[str], List[bytes], List[Tuple[str, bytes]]]
        ] = {}
        _body_params: Optional[bytes] = None

        # process the path parameters
        # process the query parameters

        if _additional_query_params is not None:
            _query_params.extend((key, value) for key, value in _additional_query_params.items())

        if include is not None:
            
            _query_params.append(('include', include))
            
        if sort is not None:
            
            _query_params.append(('sort', sort))
            
        if fields_invoices is not None:
            
            _query_params.append(('fields[invoices]', fields_invoices))
            
        if filter_id_eq is not None:
            
            _query_params.append(('filter[id][eq]', filter_id_eq))
            
        if filter_id_not_eq is not None:
            
            _query_params.append(('filter[id][not_eq]', filter_id_not_eq))
            
        if filter_id_gt is not None:
            
            _query_params.append(('filter[id][gt]', filter_id_gt))
            
        if filter_id_gte is not None:
            
            _query_params.append(('filter[id][gte]', filter_id_gte))
            
        if filter_id_lt is not None:
            
            _query_params.append(('filter[id][lt]', filter_id_lt))
            
        if filter_id_lte is not None:
            
            _query_params.append(('filter[id][lte]', filter_id_lte))
            
        if filter_group_id_eq is not None:
            
            _query_params.append(('filter[group_id][eq]', filter_group_id_eq))
            
        if filter_group_id_not_eq is not None:
            
            _query_params.append(('filter[group_id][not_eq]', filter_group_id_not_eq))
            
        if filter_group_id_gt is not None:
            
            _query_params.append(('filter[group_id][gt]', filter_group_id_gt))
            
        if filter_group_id_gte is not None:
            
            _query_params.append(('filter[group_id][gte]', filter_group_id_gte))
            
        if filter_group_id_lt is not None:
            
            _query_params.append(('filter[group_id][lt]', filter_group_id_lt))
            
        if filter_group_id_lte is not None:
            
            _query_params.append(('filter[group_id][lte]', filter_group_id_lte))
            
        if filter_recipient_id_eq is not None:
            
            _query_params.append(('filter[recipient_id][eq]', filter_recipient_id_eq))
            
        if filter_recipient_id_not_eq is not None:
            
            _query_params.append(('filter[recipient_id][not_eq]', filter_recipient_id_not_eq))
            
        if filter_recipient_id_gt is not None:
            
            _query_params.append(('filter[recipient_id][gt]', filter_recipient_id_gt))
            
        if filter_recipient_id_gte is not None:
            
            _query_params.append(('filter[recipient_id][gte]', filter_recipient_id_gte))
            
        if filter_recipient_id_lt is not None:
            
            _query_params.append(('filter[recipient_id][lt]', filter_recipient_id_lt))
            
        if filter_recipient_id_lte is not None:
            
            _query_params.append(('filter[recipient_id][lte]', filter_recipient_id_lte))
            
        if fields_groups is not None:
            
            _query_params.append(('fields[groups]', fields_groups))
            
        if fields_people is not None:
            
            _query_params.append(('fields[people]', fields_people))
            
        if fields_invoice_items is not None:
            
            _query_params.append(('fields[invoice_items]', fields_invoice_items))
            
        # process the header parameters
        # process the form parameters
        # process the body parameter


        # set the HTTP header `Accept`
        if 'Accept' not in _header_params:
            _header_params['Accept'] = self.api_client.select_header_accept(
                [
                    'application/vnd.api+json'
                ]
            )


        # authentication setting
        _auth_settings: List[str] = [
            'ServiceTokenAuthHeader', 
            'ServiceTokenAuthParam'
        ]

        return self.api_client.param_serialize(
            method='GET',
            resource_path='/api/invoices',
            path_params=_path_params,
            query_params=_query_params,
            header_params=_header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            auth_settings=_auth_settings,
            collection_formats=_collection_formats,
            _host=_host,
            _request_auth=_request_auth
        )




    @validate_call
    def update_invoice(
        self,
        id: Annotated[StrictStr, Field(description="ID of the resource")],
        invoices_request: InvoicesRequest,
        include: Annotated[Optional[List[StrictStr]], Field(description="[Include related resources](https://jsonapi.org/format/#fetching-includes)")] = None,
        sort: Annotated[Optional[List[StrictStr]], Field(description="[Sort invoices according to one or more criteria](https://jsonapi.org/format/#fetching-sorting)  You should not include both ascending `id` and descending `-id` fields the same time  ")] = None,
        fields_invoices: Annotated[Optional[List[InvoicesReadableAttribute]], Field(description="[Include only specified fields of Invoice in response](https://jsonapi.org/format/#fetching-sparse-fieldsets)")] = None,
        filter_id_eq: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by id using eq operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_id_not_eq: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by id using not_eq operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_id_gt: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by id using gt operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_id_gte: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by id using gte operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_id_lt: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by id using lt operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_id_lte: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by id using lte operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_group_id_eq: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by group_id using eq operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_group_id_not_eq: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by group_id using not_eq operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_group_id_gt: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by group_id using gt operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_group_id_gte: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by group_id using gte operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_group_id_lt: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by group_id using lt operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_group_id_lte: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by group_id using lte operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_recipient_id_eq: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by recipient_id using eq operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_recipient_id_not_eq: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by recipient_id using not_eq operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_recipient_id_gt: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by recipient_id using gt operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_recipient_id_gte: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by recipient_id using gte operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_recipient_id_lt: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by recipient_id using lt operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_recipient_id_lte: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by recipient_id using lte operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        fields_groups: Annotated[Optional[List[GroupsReadableAttribute]], Field(description="[Include only specified fields of Group in response](https://jsonapi.org/format/#fetching-sparse-fieldsets)")] = None,
        fields_people: Annotated[Optional[List[PeopleReadableAttribute]], Field(description="[Include only specified fields of Person in response](https://jsonapi.org/format/#fetching-sparse-fieldsets)")] = None,
        fields_invoice_items: Annotated[Optional[List[InvoiceItemsReadableAttribute]], Field(description="[Include only specified fields of Invoice item in response](https://jsonapi.org/format/#fetching-sparse-fieldsets)")] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
        _additional_query_params: Optional[Dict[StrictStr, Any]] = None,
    ) -> InvoicesSingle:
        """Update Invoice


        :param id: ID of the resource (required)
        :type id: str
        :param invoices_request: (required)
        :type invoices_request: InvoicesRequest
        :param include: [Include related resources](https://jsonapi.org/format/#fetching-includes)
        :type include: List[str]
        :param sort: [Sort invoices according to one or more criteria](https://jsonapi.org/format/#fetching-sorting)  You should not include both ascending `id` and descending `-id` fields the same time  
        :type sort: List[str]
        :param fields_invoices: [Include only specified fields of Invoice in response](https://jsonapi.org/format/#fetching-sparse-fieldsets)
        :type fields_invoices: List[InvoicesReadableAttribute]
        :param filter_id_eq: [Filter Invoice by id using eq operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_id_eq: List[int]
        :param filter_id_not_eq: [Filter Invoice by id using not_eq operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_id_not_eq: List[int]
        :param filter_id_gt: [Filter Invoice by id using gt operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_id_gt: List[int]
        :param filter_id_gte: [Filter Invoice by id using gte operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_id_gte: List[int]
        :param filter_id_lt: [Filter Invoice by id using lt operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_id_lt: List[int]
        :param filter_id_lte: [Filter Invoice by id using lte operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_id_lte: List[int]
        :param filter_group_id_eq: [Filter Invoice by group_id using eq operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_group_id_eq: List[int]
        :param filter_group_id_not_eq: [Filter Invoice by group_id using not_eq operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_group_id_not_eq: List[int]
        :param filter_group_id_gt: [Filter Invoice by group_id using gt operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_group_id_gt: List[int]
        :param filter_group_id_gte: [Filter Invoice by group_id using gte operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_group_id_gte: List[int]
        :param filter_group_id_lt: [Filter Invoice by group_id using lt operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_group_id_lt: List[int]
        :param filter_group_id_lte: [Filter Invoice by group_id using lte operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_group_id_lte: List[int]
        :param filter_recipient_id_eq: [Filter Invoice by recipient_id using eq operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_recipient_id_eq: List[int]
        :param filter_recipient_id_not_eq: [Filter Invoice by recipient_id using not_eq operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_recipient_id_not_eq: List[int]
        :param filter_recipient_id_gt: [Filter Invoice by recipient_id using gt operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_recipient_id_gt: List[int]
        :param filter_recipient_id_gte: [Filter Invoice by recipient_id using gte operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_recipient_id_gte: List[int]
        :param filter_recipient_id_lt: [Filter Invoice by recipient_id using lt operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_recipient_id_lt: List[int]
        :param filter_recipient_id_lte: [Filter Invoice by recipient_id using lte operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_recipient_id_lte: List[int]
        :param fields_groups: [Include only specified fields of Group in response](https://jsonapi.org/format/#fetching-sparse-fieldsets)
        :type fields_groups: List[GroupsReadableAttribute]
        :param fields_people: [Include only specified fields of Person in response](https://jsonapi.org/format/#fetching-sparse-fieldsets)
        :type fields_people: List[PeopleReadableAttribute]
        :param fields_invoice_items: [Include only specified fields of Invoice item in response](https://jsonapi.org/format/#fetching-sparse-fieldsets)
        :type fields_invoice_items: List[InvoiceItemsReadableAttribute]
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._update_invoice_serialize(
            id=id,
            invoices_request=invoices_request,
            include=include,
            sort=sort,
            fields_invoices=fields_invoices,
            filter_id_eq=filter_id_eq,
            filter_id_not_eq=filter_id_not_eq,
            filter_id_gt=filter_id_gt,
            filter_id_gte=filter_id_gte,
            filter_id_lt=filter_id_lt,
            filter_id_lte=filter_id_lte,
            filter_group_id_eq=filter_group_id_eq,
            filter_group_id_not_eq=filter_group_id_not_eq,
            filter_group_id_gt=filter_group_id_gt,
            filter_group_id_gte=filter_group_id_gte,
            filter_group_id_lt=filter_group_id_lt,
            filter_group_id_lte=filter_group_id_lte,
            filter_recipient_id_eq=filter_recipient_id_eq,
            filter_recipient_id_not_eq=filter_recipient_id_not_eq,
            filter_recipient_id_gt=filter_recipient_id_gt,
            filter_recipient_id_gte=filter_recipient_id_gte,
            filter_recipient_id_lt=filter_recipient_id_lt,
            filter_recipient_id_lte=filter_recipient_id_lte,
            fields_groups=fields_groups,
            fields_people=fields_people,
            fields_invoice_items=fields_invoice_items,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index,
            _additional_query_params=_additional_query_params,
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "InvoicesSingle",
            '202': None,
            '204': None,
            '401': "JsonapiFailure",
            '403': "JsonapiFailure",
            '404': "JsonapiFailure",
            '422': "JsonapiFailure",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        ).data


    @validate_call
    def update_invoice_with_http_info(
        self,
        id: Annotated[StrictStr, Field(description="ID of the resource")],
        invoices_request: InvoicesRequest,
        include: Annotated[Optional[List[StrictStr]], Field(description="[Include related resources](https://jsonapi.org/format/#fetching-includes)")] = None,
        sort: Annotated[Optional[List[StrictStr]], Field(description="[Sort invoices according to one or more criteria](https://jsonapi.org/format/#fetching-sorting)  You should not include both ascending `id` and descending `-id` fields the same time  ")] = None,
        fields_invoices: Annotated[Optional[List[InvoicesReadableAttribute]], Field(description="[Include only specified fields of Invoice in response](https://jsonapi.org/format/#fetching-sparse-fieldsets)")] = None,
        filter_id_eq: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by id using eq operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_id_not_eq: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by id using not_eq operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_id_gt: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by id using gt operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_id_gte: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by id using gte operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_id_lt: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by id using lt operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_id_lte: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by id using lte operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_group_id_eq: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by group_id using eq operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_group_id_not_eq: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by group_id using not_eq operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_group_id_gt: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by group_id using gt operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_group_id_gte: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by group_id using gte operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_group_id_lt: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by group_id using lt operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_group_id_lte: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by group_id using lte operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_recipient_id_eq: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by recipient_id using eq operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_recipient_id_not_eq: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by recipient_id using not_eq operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_recipient_id_gt: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by recipient_id using gt operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_recipient_id_gte: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by recipient_id using gte operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_recipient_id_lt: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by recipient_id using lt operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_recipient_id_lte: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by recipient_id using lte operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        fields_groups: Annotated[Optional[List[GroupsReadableAttribute]], Field(description="[Include only specified fields of Group in response](https://jsonapi.org/format/#fetching-sparse-fieldsets)")] = None,
        fields_people: Annotated[Optional[List[PeopleReadableAttribute]], Field(description="[Include only specified fields of Person in response](https://jsonapi.org/format/#fetching-sparse-fieldsets)")] = None,
        fields_invoice_items: Annotated[Optional[List[InvoiceItemsReadableAttribute]], Field(description="[Include only specified fields of Invoice item in response](https://jsonapi.org/format/#fetching-sparse-fieldsets)")] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
        _additional_query_params: Optional[Dict[StrictStr, Any]] = None,
    ) -> ApiResponse[InvoicesSingle]:
        """Update Invoice


        :param id: ID of the resource (required)
        :type id: str
        :param invoices_request: (required)
        :type invoices_request: InvoicesRequest
        :param include: [Include related resources](https://jsonapi.org/format/#fetching-includes)
        :type include: List[str]
        :param sort: [Sort invoices according to one or more criteria](https://jsonapi.org/format/#fetching-sorting)  You should not include both ascending `id` and descending `-id` fields the same time  
        :type sort: List[str]
        :param fields_invoices: [Include only specified fields of Invoice in response](https://jsonapi.org/format/#fetching-sparse-fieldsets)
        :type fields_invoices: List[InvoicesReadableAttribute]
        :param filter_id_eq: [Filter Invoice by id using eq operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_id_eq: List[int]
        :param filter_id_not_eq: [Filter Invoice by id using not_eq operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_id_not_eq: List[int]
        :param filter_id_gt: [Filter Invoice by id using gt operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_id_gt: List[int]
        :param filter_id_gte: [Filter Invoice by id using gte operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_id_gte: List[int]
        :param filter_id_lt: [Filter Invoice by id using lt operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_id_lt: List[int]
        :param filter_id_lte: [Filter Invoice by id using lte operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_id_lte: List[int]
        :param filter_group_id_eq: [Filter Invoice by group_id using eq operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_group_id_eq: List[int]
        :param filter_group_id_not_eq: [Filter Invoice by group_id using not_eq operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_group_id_not_eq: List[int]
        :param filter_group_id_gt: [Filter Invoice by group_id using gt operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_group_id_gt: List[int]
        :param filter_group_id_gte: [Filter Invoice by group_id using gte operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_group_id_gte: List[int]
        :param filter_group_id_lt: [Filter Invoice by group_id using lt operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_group_id_lt: List[int]
        :param filter_group_id_lte: [Filter Invoice by group_id using lte operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_group_id_lte: List[int]
        :param filter_recipient_id_eq: [Filter Invoice by recipient_id using eq operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_recipient_id_eq: List[int]
        :param filter_recipient_id_not_eq: [Filter Invoice by recipient_id using not_eq operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_recipient_id_not_eq: List[int]
        :param filter_recipient_id_gt: [Filter Invoice by recipient_id using gt operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_recipient_id_gt: List[int]
        :param filter_recipient_id_gte: [Filter Invoice by recipient_id using gte operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_recipient_id_gte: List[int]
        :param filter_recipient_id_lt: [Filter Invoice by recipient_id using lt operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_recipient_id_lt: List[int]
        :param filter_recipient_id_lte: [Filter Invoice by recipient_id using lte operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_recipient_id_lte: List[int]
        :param fields_groups: [Include only specified fields of Group in response](https://jsonapi.org/format/#fetching-sparse-fieldsets)
        :type fields_groups: List[GroupsReadableAttribute]
        :param fields_people: [Include only specified fields of Person in response](https://jsonapi.org/format/#fetching-sparse-fieldsets)
        :type fields_people: List[PeopleReadableAttribute]
        :param fields_invoice_items: [Include only specified fields of Invoice item in response](https://jsonapi.org/format/#fetching-sparse-fieldsets)
        :type fields_invoice_items: List[InvoiceItemsReadableAttribute]
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._update_invoice_serialize(
            id=id,
            invoices_request=invoices_request,
            include=include,
            sort=sort,
            fields_invoices=fields_invoices,
            filter_id_eq=filter_id_eq,
            filter_id_not_eq=filter_id_not_eq,
            filter_id_gt=filter_id_gt,
            filter_id_gte=filter_id_gte,
            filter_id_lt=filter_id_lt,
            filter_id_lte=filter_id_lte,
            filter_group_id_eq=filter_group_id_eq,
            filter_group_id_not_eq=filter_group_id_not_eq,
            filter_group_id_gt=filter_group_id_gt,
            filter_group_id_gte=filter_group_id_gte,
            filter_group_id_lt=filter_group_id_lt,
            filter_group_id_lte=filter_group_id_lte,
            filter_recipient_id_eq=filter_recipient_id_eq,
            filter_recipient_id_not_eq=filter_recipient_id_not_eq,
            filter_recipient_id_gt=filter_recipient_id_gt,
            filter_recipient_id_gte=filter_recipient_id_gte,
            filter_recipient_id_lt=filter_recipient_id_lt,
            filter_recipient_id_lte=filter_recipient_id_lte,
            fields_groups=fields_groups,
            fields_people=fields_people,
            fields_invoice_items=fields_invoice_items,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index,
            _additional_query_params=_additional_query_params,
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "InvoicesSingle",
            '202': None,
            '204': None,
            '401': "JsonapiFailure",
            '403': "JsonapiFailure",
            '404': "JsonapiFailure",
            '422': "JsonapiFailure",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        )


    @validate_call
    def update_invoice_without_preload_content(
        self,
        id: Annotated[StrictStr, Field(description="ID of the resource")],
        invoices_request: InvoicesRequest,
        include: Annotated[Optional[List[StrictStr]], Field(description="[Include related resources](https://jsonapi.org/format/#fetching-includes)")] = None,
        sort: Annotated[Optional[List[StrictStr]], Field(description="[Sort invoices according to one or more criteria](https://jsonapi.org/format/#fetching-sorting)  You should not include both ascending `id` and descending `-id` fields the same time  ")] = None,
        fields_invoices: Annotated[Optional[List[InvoicesReadableAttribute]], Field(description="[Include only specified fields of Invoice in response](https://jsonapi.org/format/#fetching-sparse-fieldsets)")] = None,
        filter_id_eq: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by id using eq operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_id_not_eq: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by id using not_eq operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_id_gt: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by id using gt operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_id_gte: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by id using gte operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_id_lt: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by id using lt operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_id_lte: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by id using lte operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_group_id_eq: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by group_id using eq operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_group_id_not_eq: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by group_id using not_eq operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_group_id_gt: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by group_id using gt operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_group_id_gte: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by group_id using gte operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_group_id_lt: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by group_id using lt operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_group_id_lte: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by group_id using lte operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_recipient_id_eq: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by recipient_id using eq operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_recipient_id_not_eq: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by recipient_id using not_eq operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_recipient_id_gt: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by recipient_id using gt operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_recipient_id_gte: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by recipient_id using gte operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_recipient_id_lt: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by recipient_id using lt operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        filter_recipient_id_lte: Annotated[Optional[List[StrictInt]], Field(description="[Filter Invoice by recipient_id using lte operator](https://jsonapi.org/format/#fetching-filtering)")] = None,
        fields_groups: Annotated[Optional[List[GroupsReadableAttribute]], Field(description="[Include only specified fields of Group in response](https://jsonapi.org/format/#fetching-sparse-fieldsets)")] = None,
        fields_people: Annotated[Optional[List[PeopleReadableAttribute]], Field(description="[Include only specified fields of Person in response](https://jsonapi.org/format/#fetching-sparse-fieldsets)")] = None,
        fields_invoice_items: Annotated[Optional[List[InvoiceItemsReadableAttribute]], Field(description="[Include only specified fields of Invoice item in response](https://jsonapi.org/format/#fetching-sparse-fieldsets)")] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
        _additional_query_params: Optional[Dict[StrictStr, Any]] = None,
    ) -> RESTResponseType:
        """Update Invoice


        :param id: ID of the resource (required)
        :type id: str
        :param invoices_request: (required)
        :type invoices_request: InvoicesRequest
        :param include: [Include related resources](https://jsonapi.org/format/#fetching-includes)
        :type include: List[str]
        :param sort: [Sort invoices according to one or more criteria](https://jsonapi.org/format/#fetching-sorting)  You should not include both ascending `id` and descending `-id` fields the same time  
        :type sort: List[str]
        :param fields_invoices: [Include only specified fields of Invoice in response](https://jsonapi.org/format/#fetching-sparse-fieldsets)
        :type fields_invoices: List[InvoicesReadableAttribute]
        :param filter_id_eq: [Filter Invoice by id using eq operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_id_eq: List[int]
        :param filter_id_not_eq: [Filter Invoice by id using not_eq operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_id_not_eq: List[int]
        :param filter_id_gt: [Filter Invoice by id using gt operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_id_gt: List[int]
        :param filter_id_gte: [Filter Invoice by id using gte operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_id_gte: List[int]
        :param filter_id_lt: [Filter Invoice by id using lt operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_id_lt: List[int]
        :param filter_id_lte: [Filter Invoice by id using lte operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_id_lte: List[int]
        :param filter_group_id_eq: [Filter Invoice by group_id using eq operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_group_id_eq: List[int]
        :param filter_group_id_not_eq: [Filter Invoice by group_id using not_eq operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_group_id_not_eq: List[int]
        :param filter_group_id_gt: [Filter Invoice by group_id using gt operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_group_id_gt: List[int]
        :param filter_group_id_gte: [Filter Invoice by group_id using gte operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_group_id_gte: List[int]
        :param filter_group_id_lt: [Filter Invoice by group_id using lt operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_group_id_lt: List[int]
        :param filter_group_id_lte: [Filter Invoice by group_id using lte operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_group_id_lte: List[int]
        :param filter_recipient_id_eq: [Filter Invoice by recipient_id using eq operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_recipient_id_eq: List[int]
        :param filter_recipient_id_not_eq: [Filter Invoice by recipient_id using not_eq operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_recipient_id_not_eq: List[int]
        :param filter_recipient_id_gt: [Filter Invoice by recipient_id using gt operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_recipient_id_gt: List[int]
        :param filter_recipient_id_gte: [Filter Invoice by recipient_id using gte operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_recipient_id_gte: List[int]
        :param filter_recipient_id_lt: [Filter Invoice by recipient_id using lt operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_recipient_id_lt: List[int]
        :param filter_recipient_id_lte: [Filter Invoice by recipient_id using lte operator](https://jsonapi.org/format/#fetching-filtering)
        :type filter_recipient_id_lte: List[int]
        :param fields_groups: [Include only specified fields of Group in response](https://jsonapi.org/format/#fetching-sparse-fieldsets)
        :type fields_groups: List[GroupsReadableAttribute]
        :param fields_people: [Include only specified fields of Person in response](https://jsonapi.org/format/#fetching-sparse-fieldsets)
        :type fields_people: List[PeopleReadableAttribute]
        :param fields_invoice_items: [Include only specified fields of Invoice item in response](https://jsonapi.org/format/#fetching-sparse-fieldsets)
        :type fields_invoice_items: List[InvoiceItemsReadableAttribute]
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._update_invoice_serialize(
            id=id,
            invoices_request=invoices_request,
            include=include,
            sort=sort,
            fields_invoices=fields_invoices,
            filter_id_eq=filter_id_eq,
            filter_id_not_eq=filter_id_not_eq,
            filter_id_gt=filter_id_gt,
            filter_id_gte=filter_id_gte,
            filter_id_lt=filter_id_lt,
            filter_id_lte=filter_id_lte,
            filter_group_id_eq=filter_group_id_eq,
            filter_group_id_not_eq=filter_group_id_not_eq,
            filter_group_id_gt=filter_group_id_gt,
            filter_group_id_gte=filter_group_id_gte,
            filter_group_id_lt=filter_group_id_lt,
            filter_group_id_lte=filter_group_id_lte,
            filter_recipient_id_eq=filter_recipient_id_eq,
            filter_recipient_id_not_eq=filter_recipient_id_not_eq,
            filter_recipient_id_gt=filter_recipient_id_gt,
            filter_recipient_id_gte=filter_recipient_id_gte,
            filter_recipient_id_lt=filter_recipient_id_lt,
            filter_recipient_id_lte=filter_recipient_id_lte,
            fields_groups=fields_groups,
            fields_people=fields_people,
            fields_invoice_items=fields_invoice_items,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index,
            _additional_query_params=_additional_query_params,
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "InvoicesSingle",
            '202': None,
            '204': None,
            '401': "JsonapiFailure",
            '403': "JsonapiFailure",
            '404': "JsonapiFailure",
            '422': "JsonapiFailure",
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        return response_data.response


    def _update_invoice_serialize(
        self,
        id,
        invoices_request,
        include,
        sort,
        fields_invoices,
        filter_id_eq,
        filter_id_not_eq,
        filter_id_gt,
        filter_id_gte,
        filter_id_lt,
        filter_id_lte,
        filter_group_id_eq,
        filter_group_id_not_eq,
        filter_group_id_gt,
        filter_group_id_gte,
        filter_group_id_lt,
        filter_group_id_lte,
        filter_recipient_id_eq,
        filter_recipient_id_not_eq,
        filter_recipient_id_gt,
        filter_recipient_id_gte,
        filter_recipient_id_lt,
        filter_recipient_id_lte,
        fields_groups,
        fields_people,
        fields_invoice_items,
        _request_auth,
        _content_type,
        _headers,
        _host_index,
        _additional_query_params: Optional[Dict[StrictStr, Any]] = None,
    ) -> RequestSerialized:

        _host = None

        _collection_formats: Dict[str, str] = {
            'include': 'csv',
            'sort': 'csv',
            'fields[invoices]': 'csv',
            'filter[id][eq]': 'csv',
            'filter[id][not_eq]': 'csv',
            'filter[id][gt]': 'csv',
            'filter[id][gte]': 'csv',
            'filter[id][lt]': 'csv',
            'filter[id][lte]': 'csv',
            'filter[group_id][eq]': 'csv',
            'filter[group_id][not_eq]': 'csv',
            'filter[group_id][gt]': 'csv',
            'filter[group_id][gte]': 'csv',
            'filter[group_id][lt]': 'csv',
            'filter[group_id][lte]': 'csv',
            'filter[recipient_id][eq]': 'csv',
            'filter[recipient_id][not_eq]': 'csv',
            'filter[recipient_id][gt]': 'csv',
            'filter[recipient_id][gte]': 'csv',
            'filter[recipient_id][lt]': 'csv',
            'filter[recipient_id][lte]': 'csv',
            'fields[groups]': 'csv',
            'fields[people]': 'csv',
            'fields[invoice_items]': 'csv',
        }

        _path_params: Dict[str, str] = {}
        _query_params: List[Tuple[str, str]] = []
        _header_params: Dict[str, Optional[str]] = _headers or {}
        _form_params: List[Tuple[str, str]] = []
        _files: Dict[
            str, Union[str, bytes, List[str], List[bytes], List[Tuple[str, bytes]]]
        ] = {}
        _body_params: Optional[bytes] = None

        # process the path parameters
        if id is not None:
            _path_params['id'] = id
        # process the query parameters

        if _additional_query_params is not None:
            _query_params.extend((key, value) for key, value in _additional_query_params.items())

        if include is not None:
            
            _query_params.append(('include', include))
            
        if sort is not None:
            
            _query_params.append(('sort', sort))
            
        if fields_invoices is not None:
            
            _query_params.append(('fields[invoices]', fields_invoices))
            
        if filter_id_eq is not None:
            
            _query_params.append(('filter[id][eq]', filter_id_eq))
            
        if filter_id_not_eq is not None:
            
            _query_params.append(('filter[id][not_eq]', filter_id_not_eq))
            
        if filter_id_gt is not None:
            
            _query_params.append(('filter[id][gt]', filter_id_gt))
            
        if filter_id_gte is not None:
            
            _query_params.append(('filter[id][gte]', filter_id_gte))
            
        if filter_id_lt is not None:
            
            _query_params.append(('filter[id][lt]', filter_id_lt))
            
        if filter_id_lte is not None:
            
            _query_params.append(('filter[id][lte]', filter_id_lte))
            
        if filter_group_id_eq is not None:
            
            _query_params.append(('filter[group_id][eq]', filter_group_id_eq))
            
        if filter_group_id_not_eq is not None:
            
            _query_params.append(('filter[group_id][not_eq]', filter_group_id_not_eq))
            
        if filter_group_id_gt is not None:
            
            _query_params.append(('filter[group_id][gt]', filter_group_id_gt))
            
        if filter_group_id_gte is not None:
            
            _query_params.append(('filter[group_id][gte]', filter_group_id_gte))
            
        if filter_group_id_lt is not None:
            
            _query_params.append(('filter[group_id][lt]', filter_group_id_lt))
            
        if filter_group_id_lte is not None:
            
            _query_params.append(('filter[group_id][lte]', filter_group_id_lte))
            
        if filter_recipient_id_eq is not None:
            
            _query_params.append(('filter[recipient_id][eq]', filter_recipient_id_eq))
            
        if filter_recipient_id_not_eq is not None:
            
            _query_params.append(('filter[recipient_id][not_eq]', filter_recipient_id_not_eq))
            
        if filter_recipient_id_gt is not None:
            
            _query_params.append(('filter[recipient_id][gt]', filter_recipient_id_gt))
            
        if filter_recipient_id_gte is not None:
            
            _query_params.append(('filter[recipient_id][gte]', filter_recipient_id_gte))
            
        if filter_recipient_id_lt is not None:
            
            _query_params.append(('filter[recipient_id][lt]', filter_recipient_id_lt))
            
        if filter_recipient_id_lte is not None:
            
            _query_params.append(('filter[recipient_id][lte]', filter_recipient_id_lte))
            
        if fields_groups is not None:
            
            _query_params.append(('fields[groups]', fields_groups))
            
        if fields_people is not None:
            
            _query_params.append(('fields[people]', fields_people))
            
        if fields_invoice_items is not None:
            
            _query_params.append(('fields[invoice_items]', fields_invoice_items))
            
        # process the header parameters
        # process the form parameters
        # process the body parameter
        if invoices_request is not None:
            _body_params = invoices_request


        # set the HTTP header `Accept`
        if 'Accept' not in _header_params:
            _header_params['Accept'] = self.api_client.select_header_accept(
                [
                    'application/vnd.api+json'
                ]
            )

        # set the HTTP header `Content-Type`
        if _content_type:
            _header_params['Content-Type'] = _content_type
        else:
            _default_content_type = (
                self.api_client.select_header_content_type(
                    [
                        'application/vnd.api+json'
                    ]
                )
            )
            if _default_content_type is not None:
                _header_params['Content-Type'] = _default_content_type

        # authentication setting
        _auth_settings: List[str] = [
            'ServiceTokenAuthHeader', 
            'ServiceTokenAuthParam'
        ]

        return self.api_client.param_serialize(
            method='PUT',
            resource_path='/api/invoices/{id}',
            path_params=_path_params,
            query_params=_query_params,
            header_params=_header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            auth_settings=_auth_settings,
            collection_formats=_collection_formats,
            _host=_host,
            _request_auth=_request_auth
        )


